#define MAX_LEVELS 5

#import "AppDelegate.h"
#import "SSMenu.h"

@implementation AppDelegate

- (NSMutableArray*)menus {
	return _menus ;
}

- (void)showMenus:(id)userInfoNotUsed {
	[_timer invalidate] ;
	_timer = nil ;
	
	NSEnumerator* e = [_menus objectEnumerator] ;
	NSValue* p ;
	NSString* punctuation = [_menus count] ? @":" : @"." ;
	NSLog(@"There are %i currently allocced menus%@", [_menus count], punctuation) ;
	while ((p = [e nextObject])) {
		SSMenu* menu = [p pointerValue] ;
		NSLog(@"   %x %@", menu, [menu title]) ;
	}
}

- (void)showMenusBeforeAndAfter {
	// Show immediately
	[self showMenus:nil] ;
	// Set timer to show again in a few hundred milliseconds
	_timer = [NSTimer scheduledTimerWithTimeInterval:0.4
											  target:self
											selector:@selector(showMenus:)
											userInfo:nil
											 repeats:NO] ;
}

- (void)awakeFromNib {
	[NSApp setDelegate:self] ;
	
	_synth = [[NSSpeechSynthesizer alloc] initWithVoice:nil] ;
	_item1 = @"Item 1" ;
	_menus = [[NSMutableArray alloc] init] ;
	
	[[NSNotificationCenter defaultCenter] addObserver:self
											 selector:@selector(showMenusBeforeAndAfter)
												 name:NSMenuDidEndTrackingNotification
											   object:nil] ;
}    


// ********* Hierarchical Menu Delegate Methods ****

- (int)numberOfItemsInMenu:(SSMenu*)menu {
	return 1 ;
}

- (BOOL)menu:(SSMenu*)menu
  updateItem:(NSMenuItem*)item
	 atIndex:(int)index
shouldCancel:(BOOL)shouldCancel {
	int level = [menu level] ;
	NSString* title = [NSString stringWithFormat:@"Dude %i", level] ;
	[item setTitle:title] ;
	[item setTarget:self] ;
	[item setAction:@selector(ouch:)] ;
			
	if (level < MAX_LEVELS) {
		NSString* title = [NSString stringWithFormat:@"Sub%i", level] ;
		SSMenu* submenu = [[SSMenu alloc] initWithTitle:title] ;
		[submenu setDelegate:self] ;
		[item setSubmenu:submenu] ;
		[submenu release] ;
	}
	
	return YES ;
}

- (IBAction)ouch:(id)sender {
	[_synth startSpeakingString:@"ouch!"] ;
}

// ********** DataSource delegate methods *********** 

// Nothing fancy here; just the required methods to show 1 item
- (int)outlineView:(NSOutlineView *)outlineView numberOfChildrenOfItem:(id)item {
	return (item ? 0 : 1) ;
}
- (BOOL)outlineView:(NSOutlineView *)outlineView isItemExpandable:(id)item {
	return !(item == _item1) ;
}
- (id)outlineView:(NSOutlineView *)outlineView child:(int)index ofItem:(id)item {
	return _item1 ;
}
- (id)outlineView:(NSOutlineView *)outlineView objectValueForTableColumn:(NSTableColumn *)tableColumn byItem:(id)item  {
    return @"Right/control Click Me" ;
}


@end
